## GstVaapiPixmap

GstVaapiPixmap — Pixmap abstraction

## Functions

GstVaapiPixmap * | gst_vaapi_pixmap_ref ()
void | gst_vaapi_pixmap_unref ()
void | gst_vaapi_pixmap_replace ()
GstVideoFormat | gst_vaapi_pixmap_get_format ()
guint | gst_vaapi_pixmap_get_width ()
guint | gst_vaapi_pixmap_get_height ()
void | gst_vaapi_pixmap_get_size ()
gboolean | gst_vaapi_pixmap_put_surface ()

## Types and Values

| GstVaapiPixmap

## Object Hierarchy

## Description

## Functions

### gst_vaapi_pixmap_ref ()

    GstVaapiPixmap *
    gst_vaapi_pixmap_ref (GstVaapiPixmap *pixmap);

Atomically increases the reference count of the given `pixmap` by one.

#### Parameters

pixmap | a GstVaapiPixmap |

#### Returns

The same `pixmap` argument

### gst_vaapi_pixmap_unref ()

    void
    gst_vaapi_pixmap_unref (GstVaapiPixmap *pixmap);

Atomically decreases the reference count of the `pixmap` by one. If the reference count reaches zero, the pixmap will be free'd.

#### Parameters

pixmap | a GstVaapiPixmap |

### gst_vaapi_pixmap_replace ()

    void
    gst_vaapi_pixmap_replace (GstVaapiPixmap **old_pixmap_ptr,
                              GstVaapiPixmap *new_pixmap);

Atomically replaces the pixmap pixmap held in `old_pixmap_ptr` with `new_pixmap` . This means that `old_pixmap_ptr` shall reference a valid pixmap. However, `new_pixmap` can be NULL.

#### Parameters

old_pixmap_ptr | a pointer to a GstVaapiPixmap |
new_pixmap | a GstVaapiPixmap |

### gst_vaapi_pixmap_get_format ()

    GstVideoFormat
    gst_vaapi_pixmap_get_format (GstVaapiPixmap *pixmap);

Retrieves the format of a GstVaapiPixmap.

#### Parameters

pixmap | a GstVaapiPixmap |

#### Returns

the format of the `pixmap`

### gst_vaapi_pixmap_get_width ()

    guint
    gst_vaapi_pixmap_get_width (GstVaapiPixmap *pixmap);

Retrieves the width of a GstVaapiPixmap.

#### Parameters

pixmap | a GstVaapiPixmap |

#### Returns

the width of the `pixmap` , in pixels

### gst_vaapi_pixmap_get_height ()

    guint
    gst_vaapi_pixmap_get_height (GstVaapiPixmap *pixmap);

Retrieves the height of a GstVaapiPixmap

#### Parameters

pixmap | a GstVaapiPixmap |

#### Returns

the height of the `pixmap` , in pixels

### gst_vaapi_pixmap_get_size ()

    void
    gst_vaapi_pixmap_get_size (GstVaapiPixmap *pixmap,
                               guint *width,
                               guint *height);

Retrieves the dimensions of a GstVaapiPixmap.

#### Parameters

pixmap | a GstVaapiPixmap |
width | return location for the width, or `NULL` |
height | return location for the height, or `NULL` |

### gst_vaapi_pixmap_put_surface ()

    gboolean
    gst_vaapi_pixmap_put_surface (GstVaapiPixmap *pixmap,
                                  GstVaapiSurface *surface,
                                  const GstVaapiRectangle *crop_rect,
                                  guint flags);

Renders the whole `surface` , or a cropped region defined with `crop_rect` , into the `pixmap` , while scaling to fit the target pixmap. The `flags` specify how de-interlacing (if needed), color space conversion, scaling and other postprocessing transformations are performed.

#### Parameters

pixmap | a GstVaapiPixmap |
surface | a GstVaapiSurface |
crop_rect | the video cropping rectangle, or `NULL` if the entire surface is to be used. |
flags | postprocessing flags. See GstVaapiSurfaceRenderFlags |

#### Returns

`TRUE` on success

## Types and Values

### GstVaapiPixmap

    typedef struct {
    } GstVaapiPixmap;

Base class for system-dependent pixmaps.